Index: dia/dia-0.88.1/config.h.in
diff -u dia/dia-0.88.1/config.h.in:1.1.1.1 dia/dia-0.88.1/config.h.in:1.2
--- dia/dia-0.88.1/config.h.in:1.1.1.1	Mon Sep 24 10:42:06 2001
+++ dia/dia-0.88.1/config.h.in	Sun Sep 30 15:00:22 2001
@@ -59,6 +59,9 @@
 /* define to enable XIM support */
 #undef USE_XIM
 
+/* define to enable I18N support beyond Japanese localization */
+#undef USE_I18N
+
 /* Define if you have the __argz_count function.  */
 #undef HAVE___ARGZ_COUNT
 
Index: dia/dia-0.88.1/configure.in
diff -u dia/dia-0.88.1/configure.in:1.1.1.1 dia/dia-0.88.1/configure.in:1.2
--- dia/dia-0.88.1/configure.in:1.1.1.1	Mon Sep 24 10:42:06 2001
+++ dia/dia-0.88.1/configure.in	Sun Sep 30 15:00:22 2001
@@ -207,6 +207,13 @@
 dnl
 dnl i18n
 dnl
+AC_ARG_ENABLE(i18n,
+[  --disable-i18n           disable i18n code],,enable_i18n=yes)
+AC_MSG_CHECKING([whether to disable i18n support])
+if test "x$enable_i18n" != xno; then
+  AC_DEFINE(USE_I18N)
+fi
+AC_MSG_RESULT($enable_i18n)
 
 ALL_LINGUAS="az ca da de el en_GB es fi fr ga hu it ja ko nl no pl pt pt_BR ru sl sv tr uk zh_CN.GB2312 zh_TW.Big5"
 
Index: dia/dia-0.88.1/app/disp_callbacks.c
diff -u dia/dia-0.88.1/app/disp_callbacks.c:1.1.1.1 dia/dia-0.88.1/app/disp_callbacks.c:1.2
--- dia/dia-0.88.1/app/disp_callbacks.c:1.1.1.1	Mon Sep 24 10:42:07 2001
+++ dia/dia-0.88.1/app/disp_callbacks.c	Sun Sep 30 15:00:22 2001
@@ -304,7 +304,7 @@
     if (ddisp->ic == NULL)
       g_warning("could not create input context");
     else {
-      gtk_widget_add_events(ddisp->canvas, gdk_ic_get_events(ddisp->ic));
+      gtk_widget_add_events(ddisp->canvas->window, gdk_ic_get_events(ddisp->ic));
 
       if (GTK_WIDGET_HAS_FOCUS(widget))
 	gdk_im_begin(ddisp->ic, widget->window);
Index: dia/dia-0.88.1/app/render_eps.c
diff -u dia/dia-0.88.1/app/render_eps.c:1.1.1.1 dia/dia-0.88.1/app/render_eps.c:1.3.2.2
--- dia/dia-0.88.1/app/render_eps.c:1.1.1.1	Mon Sep 24 10:42:07 2001
+++ dia/dia-0.88.1/app/render_eps.c	Sun Oct 14 03:30:17 2001
@@ -1161,10 +1161,61 @@
 static void
 set_font(RendererEPS *renderer, Font *font, real height)
 {
+#ifdef USE_I18N
+  renderer->font = font;
+  renderer->font_height = height;
+#else
   fprintf(renderer->file, "/%s-latin1 ff %f scf sf\n",
 	  font_get_psfontname(font), (double)height);
+#endif
 }
 
+#ifdef USE_I18N
+static void 
+set_font_sb(RendererEPS *renderer, Font *font, real height)
+{
+  fprintf(renderer->file, " /%s-latin1 ff %f scf sf\n",
+	  font_get_psfontname(font), (double)height);
+}
+static void
+set_font_mb(RendererEPS *renderer, Font *font, real height)
+{
+  fprintf(renderer->file, " /%s-EUC-H ff %f scf sf\n",
+	  font_get_psfontname_mb(font), (double)height);
+}
+
+static int
+wc_char_len(const GdkWChar *wcsrc, int wclen, int wcpos) {
+  int len;
+  char *text;
+  GdkWChar *wc;
+  GdkWChar wc1;
+
+  wc = wcsrc;
+
+  if (wc != NULL && wcpos > wclen) {
+    return 0;
+  }
+  
+  if (wclen != wcpos) {
+    wc1 = wc[wcpos+1];
+    wc[wcpos+1] = '\0';
+    text = gdk_wcstombs(wc+wcpos);
+    wc[wcpos+1] = wc1;
+  } else {
+    text = gdk_wcstombs(wc+wcpos);
+  }
+
+  if (text == NULL) {
+    return 0;
+  } else {
+    len = strlen(text);
+    g_free(text);
+    return len;
+  }
+}
+#endif /* ifdef USE_I18N */
+
 static void
 draw_string(RendererEPS *renderer,
 	    const char *text,
@@ -1174,6 +1225,15 @@
   char *buffer;
   const char *str;
   int len;
+#ifdef USE_I18N
+  Point _pos;
+  GdkWChar *wc;
+  GdkWChar wc1;
+  int wclen;
+  int mblen;
+  int wc_cursor;
+  int sw_flag; /* single (1) or multi (2)  bytes flag */
+#endif
 
   /* TODO: Use latin-1 encoding */
 
@@ -1192,7 +1252,58 @@
       strncat(buffer, str, 1);
       str++;
     }
+   }
+#ifdef USE_I18N
+  /** basic idea
+   * 1. we need some separators to delimit the complex wc string, 
+   *   such as involving single and multi byte string.
+   **/
+  /* convert */
+  wc = g_new(GdkWChar, strlen(buffer)+1);
+  mblen = strlen(buffer);
+  wclen = gdk_mbstowcs(wc, buffer, mblen);
+  wc[wclen] = '\0';
+  
+  /* treat any arignment as ARIGN_LEFT*/
+  _pos = *pos;
+  if(alignment == ALIGN_RIGHT) {
+    _pos.x -= 
+      font_string_width(buffer, renderer->font, renderer->font_height);
+  } else if (alignment == ALIGN_CENTER) {
+    _pos.x -= 
+      font_string_width(buffer, renderer->font, renderer->font_height) / 2;
   }
+  g_free(buffer);
+  fprintf(renderer->file, "%f %f m gs 1 -1 sc\n", _pos.x, _pos.y);
+  fprintf(renderer->file, "gs\n");
+
+  sw_flag = wc_char_len(wc, wclen, 0);
+  wc_cursor = 0;
+  while (wc_cursor < wclen && sw_flag > 0) {
+    int wc_begin = wc_cursor;
+    while (wc_cursor < wclen && sw_flag == wc_char_len(wc, wclen, wc_cursor)) {
+      wc_cursor++;
+    }
+    wc1 = wc[wc_cursor];
+    wc[wc_cursor] = '\0';
+
+    if (sw_flag == 1) {
+      set_font_sb(renderer, renderer->font, renderer->font_height);
+    } else {
+      set_font_mb(renderer, renderer->font, renderer->font_height);
+    }
+    buffer = gdk_wcstombs(wc + wc_begin);
+    fprintf(renderer->file, " (%s) sh\n", buffer);
+
+    g_free(buffer);
+
+    wc[wc_cursor] = wc1;
+    sw_flag = wc_char_len(wc, wclen, wc_cursor);
+  }
+
+  fprintf(renderer->file, "gr gr\n");
+  g_free(wc);
+#else /* ! USE_I18N */
   fprintf(renderer->file, "(%s) ", buffer);
   g_free(buffer);
   
@@ -1211,6 +1322,7 @@
   }
   
   fprintf(renderer->file, " gs 1 -1 sc sh gr\n");
+#endif /* ifdef USE_I18N */
 }
 
 #endif /* HAVE_UNICODE */
Index: dia/dia-0.88.1/app/render_eps.h
diff -u dia/dia-0.88.1/app/render_eps.h:1.1.1.1 dia/dia-0.88.1/app/render_eps.h:1.2
--- dia/dia-0.88.1/app/render_eps.h:1.1.1.1	Mon Sep 24 10:42:07 2001
+++ dia/dia-0.88.1/app/render_eps.h	Sun Sep 30 15:00:22 2001
@@ -45,6 +45,10 @@
   PSUnicoder *psu;
 #endif
   Color lcolor;
+#ifdef USE_I18N
+  Font *font;
+  real font_height;
+#endif
 };
 
 RendererEPS *new_eps_renderer(Diagram *dia, char *filename);
Index: dia/dia-0.88.1/app/render_libart.c
diff -u dia/dia-0.88.1/app/render_libart.c:1.1.1.1 dia/dia-0.88.1/app/render_libart.c:1.2
--- dia/dia-0.88.1/app/render_libart.c:1.1.1.1	Mon Sep 24 10:42:07 2001
+++ dia/dia-0.88.1/app/render_libart.c	Sun Sep 30 15:00:22 2001
@@ -1110,6 +1110,92 @@
   art_svp_free( svp );
 }
 
+#ifdef USE_I18N
+static
+SuckFont *
+get_suckfont (GdkFont *font, guchar *sentence)
+{
+  SuckFont *suckfont;
+  int x, y;
+  int lbearing, rbearing, ch_width, ascent, descent;
+  GdkPixmap *pixmap;
+  GdkColor black, white;
+  GdkImage *image;
+  GdkGC *gc;
+  guchar *line;
+  int width, height;
+  int black_pixel, pixel;
+
+  if (!font)
+    return NULL;
+
+  suckfont = g_new (SuckFont, 1);
+
+  height = font->ascent + font->descent;
+  x = 0;
+  gdk_string_extents(font, sentence,
+		     &lbearing, &rbearing, &ch_width, &ascent, &descent);
+  suckfont->chars[0].left_sb = lbearing;
+  suckfont->chars[0].right_sb = ch_width - rbearing;
+  suckfont->chars[0].width = rbearing - lbearing;
+  suckfont->chars[0].ascent = ascent;
+  suckfont->chars[0].descent = descent;
+  suckfont->chars[0].bitmap_offset = x;
+  x += (ch_width + 31) & -32;
+  width = x;
+
+  suckfont->bitmap_width = width;
+  suckfont->bitmap_height = height+1;
+  suckfont->ascent = font->ascent+1;
+
+  pixmap = gdk_pixmap_new (NULL, suckfont->bitmap_width,
+			   suckfont->bitmap_height, 1);
+  gc = gdk_gc_new (pixmap);
+  gdk_gc_set_font (gc, font);
+
+  black_pixel = color_gdk_black.pixel;
+  black.pixel = black_pixel;
+  white.pixel = color_gdk_white.pixel;
+  gdk_gc_set_foreground (gc, &white);
+  gdk_draw_rectangle (pixmap, gc, 1, 0, 0, suckfont->bitmap_width, suckfont->bitmap_height);
+
+  gdk_gc_set_foreground (gc, &black);
+
+  gdk_draw_string (pixmap, font, gc,
+		   suckfont->chars[0].bitmap_offset - suckfont->chars[0].left_sb,
+		   font->ascent+1,
+		   sentence);
+
+  /* The handling of the image leaves me with distinct unease.  But this
+   * is more or less copied out of gimp/app/text_tool.c, so it _ought_ to
+   * work. -RLL
+   */
+
+  image = gdk_image_get (pixmap, 0, 0, suckfont->bitmap_width, suckfont->bitmap_height);
+  suckfont->bitmap = g_malloc0 ((width >> 3) * suckfont->bitmap_height);
+
+  line = suckfont->bitmap;
+  for (y = 0; y < suckfont->bitmap_height; y++) {
+    for (x = 0; x < suckfont->bitmap_width; x++) {
+      pixel = gdk_image_get_pixel (image, x, y);
+      if (pixel == black_pixel)
+	line[x >> 3] |= 128 >> (x & 7);
+    }
+    line += width >> 3;
+  }
+
+  gdk_image_destroy (image);
+
+  /* free the pixmap */
+  gdk_pixmap_unref (pixmap);
+
+  /* free the gc */
+  gdk_gc_destroy (gc);
+
+  return suckfont;
+}
+#endif
+
 static void
 draw_string(RendererLibart *renderer,
 	    const char *text,
@@ -1140,7 +1226,11 @@
     break;
   }
 
+#ifdef USE_I18N
+  suckfont = get_suckfont(renderer->gdk_font, text);
+#else
   suckfont = renderer->suck_font;
+#endif
 
   xpos = (double) x + 1; 
   ypos = (double) (y - suckfont->ascent);
@@ -1148,6 +1238,26 @@
   rgba = color_to_rgba(color);
   
   len = strlen(text);
+#ifdef USE_I18N
+  {
+    SuckChar *ch;
+
+    ch = &suckfont->chars[0];
+    art_affine_translate(affine, xpos, ypos);
+    art_rgb_bitmap_affine(renderer->rgb_buffer,
+			  0, 0,
+			  renderer->renderer.pixel_width,
+			  renderer->renderer.pixel_height,
+			  renderer->renderer.pixel_width*3,
+			  suckfont->bitmap + (ch->bitmap_offset >> 3),
+			  ch->width,
+			  suckfont->bitmap_height,
+			  suckfont->bitmap_width >> 3,
+			  rgba,
+			  affine,
+			  ART_FILTER_NEAREST, NULL);
+  }
+#else
   for (i = 0; i < len; i++) {
     SuckChar *ch;
     
@@ -1169,7 +1279,7 @@
     dx = ch->left_sb + ch->width + ch->right_sb;
     xpos += dx;
   }
-
+#endif
   
   
 }
@@ -1588,6 +1698,7 @@
     ptr += stride;
   }
 }
+
 
 #else
 
Index: dia/dia-0.88.1/lib/font.c
diff -u dia/dia-0.88.1/lib/font.c:1.1.1.1 dia/dia-0.88.1/lib/font.c:1.3.2.1
--- dia/dia-0.88.1/lib/font.c:1.1.1.1	Mon Sep 24 10:42:06 2001
+++ dia/dia-0.88.1/lib/font.c	Sun Oct 14 03:52:52 2001
@@ -63,6 +63,10 @@
 
 #define NUM_X11_FONTS 2
 
+#ifdef USE_I18N
+#define NUM_PS_FONTS 2
+#endif
+
 typedef struct _FontPrivate FontPrivate;
 typedef struct  _FontCacheItem FontCacheItem;
 
@@ -76,7 +80,11 @@
   Font public;
   char *fontname_x11;
   char **fontname_x11_vec;
+#ifdef USE_I18N
+  char *fontname_ps[NUM_PS_FONTS];
+#else
   char *fontname_ps;
+#endif
   FontCacheItem *cache[FONTCACHE_SIZE];
   real ascent_ratio, descent_ratio;
 };
@@ -84,10 +92,260 @@
 
 typedef struct _FontData {
   char *fontname;
+#ifdef USE_I18N
+  char *fontname_ps[NUM_PS_FONTS];
+#else
   char *fontname_ps;
+#endif
   char *fontname_x11[NUM_X11_FONTS]; /* First choice */
 } FontData;
 
+#ifdef USE_I18N
+FontData font_data[] = {
+  { "Times-Roman",
+    { "Times-Roman", "Ryumin-Light" },
+    { "-adobe-times-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Times-Italic",
+    { "Times-Italic","Ryumin-Light" },
+    { "-adobe-times-medium-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  }, 
+  { "Times-Bold",
+    { "Times-Bold","GothicBBB-Medium" },
+    { "-adobe-times-bold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  }, 
+  { "Times-BoldItalic",
+    { "Times-BoldItalic","GothicBBB-Medium" },
+    { "-adobe-times-bold-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  }, 
+  { "AvantGarde-Book",
+    { "AvantGarde-Book","Ryumin-Light" },
+    { "-adobe-avantgarde-book-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-schumacher-clean-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "AvantGarde-BookOblique",
+    { "AvantGarde-BookOblique","Ryumin-Light" },
+    { "-adobe-avantgarde-book-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-schumacher-clean-medium-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "AvantGarde-Demi",
+    { "AvantGarde-Demi","GothicBBB-Medium" },
+    { "-adobe-avantgarde-demibold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-schumacher-clean-bold-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "AvantGarde-DemiOblique",
+    { "AvantGarde-DemiOblique","GothicBBB-Medium" },
+    { "-adobe-avantgarde-demibold-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-schumacher-clean-bold-i-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "Bookman-Light",
+    { "Bookman-Light","Ryumin-Light" },
+    { "-adobe-bookman-light-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-adobe-times-medium-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "Bookman-LightItalic",
+    { "Bookman-LightItalic","Ryumin-Light" },
+    { "-adobe-bookman-light-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-adobe-times-medium-i-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "Bookman-Demi",
+    { "Bookman-Demi","GothicBBB-Medium" },
+    { "-adobe-bookman-demibold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-adobe-times-bold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "Bookman-DemiItalic",
+    { "Bookman-DemiItalic","GothicBBB-Medium" },
+    { "-adobe-bookman-demibold-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-adobe-times-bold-i-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+#ifndef G_OS_WIN32
+  { "Courier",
+    { "Courier","Ryumin-Light" },
+    { "-adobe-courier-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Courier-Oblique",
+    { "Courier-Oblique","Ryumin-Light" },
+    { "-adobe-courier-medium-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Courier-Bold",
+    { "Courier-Bold","GothicBBB-Medium" },
+    { "-adobe-courier-bold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Courier-BoldOblique",
+    { "Courier-BoldOblique","GothicBBB-Medium" },
+    { "-adobe-courier-bold-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+#else /* G_OS_WIN32 */
+  /* HB: force usage of true type font "Courier New", using the bitmap
+   * version causes scaling problems mainly with uml. FIXME: there
+   * must be a better way to do this ?
+   */
+  { "Courier",
+    { "Courier","Ryumin-Light" },
+    { "-adobe-courier new-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Courier-Oblique",
+    { "Courier-Oblique","Ryumin-Light" },
+    { "-adobe-courier new-medium-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Courier-Bold",
+    { "Courier-Bold","Ryumin-Light" },
+    { "-adobe-courier new-bold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Courier-BoldOblique",
+    { "Courier-BoldOblique","GothicBBB-Medium" },
+    { "-adobe-courier new-bold-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+#endif
+  { "Helvetica",
+    { "Helvetica", "Ryumin-Light" },
+    { "-adobe-helvetica-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Helvetica-Oblique",
+    { "Helvetica-Oblique","Ryumin-Light" },
+    { "-adobe-helvetica-medium-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Helvetica-Bold",
+    { "Helvetica-Bold","GothicBBB-Medium" },
+    { "-adobe-helvetica-bold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Helvetica-BoldOblique",
+    { "Helvetica-BoldOblique", "GothicBBB-Medium" },
+    { "-adobe-helvetica-bold-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Helvetica-Narrow",
+    { "Helvetica-Narrow", "Ryumin-Light" },
+    { "-adobe-helvetica-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Helvetica-Narrow-Oblique",
+    { "Helvetica-Narrow-Oblique", "Ryumin-Light" },
+    { "-adobe-helvetica-medium-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Helvetica-Narrow-Bold",
+    { "Helvetica-Narrow-Bold", "GothicBBB-Medium" },
+    { "-adobe-helvetica-bold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Helvetica-Narrow-BoldOblique",
+    { "Helvetica-Narrow-BoldOblique", "GothicBBB-Medium" },
+    { "-adobe-helvetica-bold-o-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "NewCenturySchoolbook-Roman",
+    { "NewCenturySchlbk-Roman", "Ryumin-Light" },
+    { "-adobe-new century schoolbook-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "NewCenturySchoolbook-Italic",
+    { "NewCenturySchlbk-Italic", "Ryumin-Light" },
+    { "-adobe-new century schoolbook-medium-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "NewCenturySchoolbook-Bold",
+    { "NewCenturySchlbk-Bold","GothicBBB-Medium" },
+    { "-adobe-new century schoolbook-bold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "NewCenturySchoolbook-BoldItalic",
+    { "NewCenturySchlbk-BoldItalic", "GothicBBB-Medium" },
+    { "-adobe-new century schoolbook-bold-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      NULL
+    }
+  },
+  { "Palatino-Roman",
+    { "Palatino-Roman", "Ryumin-Light" },
+    { "-adobe-palatino-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-*-lucidabright-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "Palatino-Italic",
+    { "Palatino-Italic", "Ryumin-Light" },
+    { "-adobe-palatino-medium-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-*-lucidabright-medium-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "Palatino-Bold",
+    { "Palatino-Bold", "GothicBBB-Medium" },
+    { "-adobe-palatino-bold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-*-lucidabright-demibold-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "Palatino-BoldItalic",
+    { "Palatino-BoldItalic", "GothicBBB-Medium" },
+    { "-adobe-palatino-bold-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-*-lucidabright-demibold-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-bold-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "Symbol",
+    { "Symbol", "Ryumin-Light" },
+    {
+      "-adobe-symbol-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-*-symbol-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "ZapfChancery-MediumItalic",
+    { "ZapfChancery-MediumItalic", "Ryumin-Light" },
+    { "-adobe-zapf chancery-medium-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-*-itc zapf chancery-medium-i-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+  { "ZapfDingbats",
+    { "ZapfDingbats", "Ryumin-Light" },
+    { "-adobe-zapf dingbats-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+      "-*-itc zapf dingbats-*-*-*-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*"
+    }
+  },
+};
+#else
 FontData font_data[] = {
   { "Times-Roman",
     "Times-Roman",
@@ -332,6 +590,7 @@
     }
   },
 };
+#endif
 
 #define NUM_FONTS (sizeof(font_data)/sizeof(FontData))
 
@@ -340,7 +599,11 @@
 GHashTable *fonts_hash = NULL;
 
 char *last_resort_fonts[] = {
+#ifdef USE_I18N
+  "-adobe-courier-medium-r-normal-*-%d-*-*-*-*-*-*-*,-jis-*-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+#else
   "-adobe-courier-medium-r-normal-*-%d-*-*-*-*-*-*-*",
+#endif
   "fixed" /* Must be last. This is guaranteed to exist on an X11 system. */
 };
 #define NUM_LAST_RESORT_FONTS (sizeof(last_resort_fonts)/sizeof(char *))
@@ -362,11 +625,21 @@
     x11_font = font->fontname_x11_vec[i];
     if (x11_font == NULL)
       break;
+#ifdef USE_I18N
+    bufsize = strlen(x11_font)+12;  /* Should be enought*/
+    buffer = (char *)g_malloc(bufsize);
+    g_snprintf(buffer, bufsize, x11_font, 100, 100);
+
+
+    gdk_font = gdk_fontset_load(buffer);
+#else
     bufsize = strlen(x11_font)+6;  /* Should be enought*/
     buffer = (char *)g_malloc(bufsize);
     g_snprintf(buffer, bufsize, x11_font, 100);
-    
+
+
     gdk_font = gdk_font_load(buffer);
+#endif
     if (gdk_font!=NULL) {
       font->fontname_x11 = x11_font;
     }
@@ -379,11 +652,19 @@
   if (font->fontname_x11 == NULL) {
     for (i=0;i<NUM_LAST_RESORT_FONTS;i++) {
       x11_font = last_resort_fonts[i];
+#ifdef USE_I18N
+      bufsize = strlen(x11_font)+12;  /* Should be enought*/
+      buffer = (char *)g_malloc(bufsize);
+      g_snprintf(buffer, bufsize, x11_font, 100, 100);
+      
+      gdk_font = gdk_fontset_load(buffer);
+#else
       bufsize = strlen(x11_font)+6;  /* Should be enought*/
       buffer = (char *)g_malloc(bufsize);
       g_snprintf(buffer, bufsize, x11_font, 100);
       
       gdk_font = gdk_font_load(buffer);
+#endif
       g_free(buffer);
       if (gdk_font!=NULL) {
 	message_warning(_("Warning no X Font for %s found, \nusing %s instead.\n"), font->public.name, x11_font);
@@ -412,7 +693,13 @@
   for (i=0;i<NUM_FONTS;i++) {
     font = g_new(FontPrivate, 1);
     font->public.name = font_data[i].fontname;
+#ifdef USE_I18N
+    for (j=0;j<NUM_PS_FONTS;j++) {
+      font->fontname_ps[j] = font_data[i].fontname_ps[j];
+    }
+#else
     font->fontname_ps = font_data[i].fontname_ps;
+#endif
 
     font->fontname_x11 = NULL;
     font->fontname_x11_vec = font_data[i].fontname_x11;
@@ -483,10 +770,17 @@
   char *buffer;
   GdkFont *gdk_font;
   
+#ifdef USE_I18N
+  bufsize = strlen(font->fontname_x11)+12;  /* Should be enought*/
+  buffer = g_new(char,bufsize);
+  g_snprintf(buffer, bufsize, font->fontname_x11, height, height);
+  gdk_font = gdk_fontset_load(buffer);
+#else
   bufsize = strlen(font->fontname_x11)+6;  /* Should be enought*/
   buffer = (char *)malloc(bufsize);
   g_snprintf(buffer, bufsize, font->fontname_x11, height);
   gdk_font = gdk_font_load(buffer);
+#endif
   free(buffer);
 
   return gdk_font;
@@ -536,6 +830,26 @@
   return cache_item->suck_font;
 }
 
+#ifdef USE_I18N
+char *
+font_get_psfontname_mb(Font *font)
+{
+  FontPrivate *fontprivate;
+
+  fontprivate = (FontPrivate *)font;
+  
+  return fontprivate->fontname_ps[1];
+}
+char *
+font_get_psfontname(Font *font)
+{
+  FontPrivate *fontprivate;
+
+  fontprivate = (FontPrivate *)font;
+  
+  return fontprivate->fontname_ps[0];
+}
+#else
 char *
 font_get_psfontname(Font *font)
 {
@@ -545,6 +859,7 @@
   
   return fontprivate->fontname_ps;
 }
+#endif
 
 real
 font_string_width(const char *string, Font *font, real height)
Index: dia/dia-0.88.1/lib/font.h
diff -u dia/dia-0.88.1/lib/font.h:1.1.1.1 dia/dia-0.88.1/lib/font.h:1.3
--- dia/dia-0.88.1/lib/font.h:1.1.1.1	Mon Sep 24 10:42:06 2001
+++ dia/dia-0.88.1/lib/font.h	Wed Oct  3 21:15:44 2001
@@ -61,6 +61,9 @@
 GdkFont *font_get_gdkfont(Font *font, int height);
 SuckFont *font_get_suckfont(Font *font, int height);
 char *font_get_psfontname(Font *font);
+#ifdef USE_I18N 
+char *font_get_psfontname_mb(Font *font);
+#endif
 real font_string_width(const char *string, Font *font, real height);
 real font_ascent(Font *font, real height);
 real font_descent(Font *font, real height);
